package servlet.examples.counter;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class InitDestroyCounter extends HttpServlet {

  
	private static final long serialVersionUID = 1L;
	int count;

  public void init() throws ServletException {
    // Megprobalja beolvasni a counter erteket egy file-bol (ahova esetleg korabban le lett mentve)
    FileReader fileReader = null;
    BufferedReader bufferedReader = null;
    try {
      fileReader = new FileReader("InitDestroyCounter.initial");
      bufferedReader = new BufferedReader(fileReader);
      String initial = bufferedReader.readLine();
      count = Integer.parseInt(initial);
      return;
    }
    catch (FileNotFoundException ignored) { }  // nem volt lementve az ertek korabban
    catch (IOException ignored) { }            // hiba olvasas kozben
    catch (NumberFormatException ignored) { }  // a lementett ertek nem szam
    finally {
      //  file bezarasa
      try {
        if (bufferedReader != null) {
          bufferedReader.close();
        }
      }
      catch (IOException ignored) { }
    }

    // Nem volt lementett ertek a file-ban, az init parameterrel probalkozunk:
    String initial = getInitParameter("initial");                    
    try {                                                            
      count = Integer.parseInt(initial);                             
      return;                                                        
    }                                                                
    catch (NumberFormatException ignored) { }  // null ertek vagy nem szam
                                                                     
    // a count alapertelmezett erteke 0 lesz                            
    count = 0;                                                       
  }                                                                  
                                                                     
  public void doGet(HttpServletRequest req, HttpServletResponse res) 
                               throws ServletException, IOException {
    res.setContentType("text/plain");                                
    PrintWriter out = res.getWriter();                               
    count++;                                                         
    out.println("Kezdettl fogva " +
                count + " alkalommal volt meghvva ez a servlet.");                                  
  }                                                                  
                                                                     
  public void destroy() {                                            
    super.destroy();  // meghivja az ososztaly destroy metodusat, opcionalis
    saveState();                                                     
  }                                                                  
                                                                     
  public void saveState() {                                          
    // Megprobalja egy  file-ba lementeni a count aktualis erteket                             
    FileWriter fileWriter = null;
    PrintWriter printWriter = null;
    try {                                                            
      fileWriter = new FileWriter("InitDestroyCounter.initial");
      printWriter = new PrintWriter(fileWriter);         
      printWriter.println(count);                                  
      return;                                                        
    }                                                                
    catch (IOException e) {  // hiba irasnal                 
                                 
    }
    finally {
      //  file bezaras
      if (printWriter != null) {
        printWriter.close();
      }
    }
  }
}
